/*$Id: c_attach.cc,v 26.8 2006/12/02 05:58:32 al Exp $ -*- C++ -*-
 * Copyright (C) 2005 Albert Davis
 * Author: Albert Davis <aldavis@ieee.org>
 *
 * This file is part of "Gnucap", the Gnu Circuit Analysis Package
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *------------------------------------------------------------------
 */
//testing=none
#include <dlfcn.h>
#include "ap.h"
#include "c_comand.h"
/*--------------------------------------------------------------------------*/
static std::map<const std::string, void*> attach_list;
/*--------------------------------------------------------------------------*/
void CMD::attach(CS& cmd)
{
  int here = cmd.cursor();
  std::string s;
  cmd >> s;

  void* handle = dlopen(s.c_str(), RTLD_NOW);
  if (handle) {
    attach_list[s] = handle;
  }else{
    cmd.warn(bERROR, here, dlerror());
  }
}
/*--------------------------------------------------------------------------*/
void CMD::detach(CS& cmd)
{
  int here = cmd.cursor();
  std::string s;
  cmd >> s;

  void* handle = attach_list[s];
  if (handle) {
    dlclose(handle);
    attach_list[s] = NULL;
  }else{
    cmd.warn(bERROR, here, "plugin not attached");
  }
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
